models/Vacuna.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "vacuna".
 *
 * @property int $vac_codigo
 * @property string $vac_nombre
 * @property string $vac_tipo
 * @property string $vac_descripcion
 * @property int $vac_stock
 * @property string $vac_dosis
 * @property int $vac_del
 *
 * @property Cita[] $citas
 */
class Vacuna extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'vacuna';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['vac_nombre', 'vac_tipo', 'vac_descripcion', 'vac_stock', 'vac_dosis', 'vac_del'], 'required'],
            [['vac_stock', 'vac_del'], 'integer'],
            [['vac_nombre', 'vac_dosis'], 'string', 'max' => 200],
            [['vac_tipo'], 'string', 'max' => 100],
            [['vac_descripcion'], 'string', 'max' => 500],
			['vac_nombre', 'unique'],
			['vac_stock', 'compare', 'compareValue' => 0, 'operator' => '>','message'=>Yii::t('app','El stock no puede ser negativo')],
        ];
    }

    /**
     * {@inheritdoc}
     */
	
	public function getDel(){
		return $this->vac_del ? 1 : 0 ;
	}
	
    public function attributeLabels()
    {
        return [
           'vac_codigo' => 'Codigo:',
            'vac_nombre' => 'Nombre:',
            'vac_tipo' => 'Tipo:',
            'vac_descripcion' => 'Descripción:',
            'vac_stock' => 'Stock:',
            'vac_dosis' => 'Dosis:',
            'vac_del' => 'Borrado',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getCitas()
    {
        return $this->hasMany(Cita::className(), ['vac_codigo' => 'vac_codigo']);
    }
}

controllers/VacunaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Vacuna;
use app\models\VacunaSearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * VacunaController implements the CRUD actions for Vacuna model.
 */
class VacunaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Vacuna models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new VacunaSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
	
	public function actionIndexpdf()
    {
        $searchModel = new VacunaSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('indexpdf', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Vacuna model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Vacuna model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
	 
	   public function actionList()
    {
        return $this->render('list');
    }
	
	
    public function actionCreate()
    {
        $model = new Vacuna();
		$model->vac_del=0;
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['/vacuna/']);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Vacuna model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['/vacuna/']);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Vacuna model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Vacuna model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Vacuna the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Vacuna::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

views/vacuna/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Vacuna */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="vacuna-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'vac_nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'vac_tipo')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'vac_descripcion')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'vac_stock')->textInput() ?>

    <?= $form->field($model, 'vac_dosis')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'vac_del')->hiddenInput()->label(false) ?>

    <div class="form-group">
        <?= Html::submitButton('Guardar', ['class' => 'btn btn-success col-xs-12']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/vacuna/_form_create.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\vacuna */
/* @var $form yii\widgets\ActiveForm */

?>
<div class="paciente-form">
    <?php $form = ActiveForm::begin(["action"=>$_SERVER['SCRIPT_NAME'].'/vacuna/create']); ?>
	<div class="panel panel-primary">
		<div class="panel-body" >
			<div class="col-xs-9 form-horizontal" style="width: 40%" >
				<?= $form->field($model, 'vac_nombre')->textInput(['maxlength' => true]) ?>
				<?= $form->field($model, 'vac_tipo')->textInput(['maxlength' => true]) ?>
				<?= $form->field($model, 'vac_dosis')->textInput(['maxlength' => true]) ?>
				
			</div>
			<div class="col-xs-9 form-horizontal" style="width: 10%" >
			</div>
			<div class="col-xs-9 form-horizontal"style="width: 40%" >
				<?= $form->field($model, 'vac_descripcion')->textInput(['maxlength' => true]) ?>
				<?= $form->field($model, 'vac_stock')->textInput() ?>
			</div>		
		</div>		
	</div>
  
	<div class="col-lg-12">
		<div class="row">
			<?= Html::a("<i class='glyphicon glyphicon-chevron-left'></i>",
				Yii::$app->homeUrl,['class'=>'btn btn-primary col-xs-5', 'style' => 'margin-bottom: 10px']) ?>
			<div class="spacer col-xs-2"></div>		
			<?= Html::submitButton('Ingresar', ['class' => 'btn btn-success col-xs-5', 'style' => 'margin-bottom: 10px']) ?>			
		</div>
	</div>
	<?php ActiveForm::end(); ?>

</div>

views/vacuna/_search.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\VacunaSearch */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="vacuna-search">

    <?php $form = ActiveForm::begin([
        'action' => ['index'],
        'method' => 'get',
    ]); ?>

    <?= $form->field($model, 'vac_codigo') ?>

    <?= $form->field($model, 'vac_nombre') ?>

    <?= $form->field($model, 'vac_tipo') ?>

    <?= $form->field($model, 'vac_descripcion') ?>

    <?= $form->field($model, 'vac_stock') ?>

    <?php // echo $form->field($model, 'vac_dosis') ?>

    <?php // echo $form->field($model, 'vac_del') ?>

    <div class="form-group">
        <?= Html::submitButton('Search', ['class' => 'btn btn-primary']) ?>
        <?= Html::resetButton('Reset', ['class' => 'btn btn-default']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/vacuna/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Vacuna */

$this->title = 'Ingresar Vacuna';
if(Yii::$app->user->isGuest){
  if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
		$uri = 'https://';
	} else {
		$uri = 'http://';
	}
	$uri .= $_SERVER['HTTP_HOST'];
	header('Location: '.$uri.'/vacunatorio/web/index.php/site/login');
	exit; 
	}
	$session = Yii::$app->session;
	$session->set('vacuna',1);
?>
<div class="vacuna-create">
    <h1><?= Html::encode($this->title) ?></h1>
    <?= $this->render('_form_create', [
        'model' => $model,
    ]) ?>

</div>

views/vacuna/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\VacunaSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */
if(Yii::$app->user->identity->usu_tipo=='Administrador/a'){
?>
<?= Html::a("Generar Informe de Vacunas",['/vacuna/indexpdf'],['class'=>'btn btn-primary col-xs-12', 'style' => 'margin-bottom: 10px; background-color:orange;']) ?>
<?php }
$this->title = 'Vacunas';
if(Yii::$app->user->isGuest){
  if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
		$uri = 'https://';
	} else {
		$uri = 'http://';
	}
	$uri .= $_SERVER['HTTP_HOST'];
	header('Location: '.$uri.'/vacunatorio/web/index.php/site/login');
	exit; 
	}
	$session = Yii::$app->session;
	if($session->get('vacuna')){ ?>
		<script>alert("Vacuna creada correctamente"); </script>
		<?php 
			$session->set('vacuna',0);
		} 
?>
</br>

<div class="vacuna-index">
    <h1><?= Html::encode($this->title) ?></h1>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            //'vac_codigo',
            'vac_nombre',
            'vac_tipo',
            'vac_descripcion',
            'vac_stock',
            //'vac_dosis',
            //'vac_del',
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
</div>
<?= Html::a("<i class='glyphicon glyphicon-chevron-left'></i>",
				Yii::$app->homeUrl,['class'=>'btn btn-primary col-xs-12', 'style' => 'margin-bottom: 10px']) ?>

views/vacuna/indexpdf.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;
use app\models\Vacuna;
/* @var $this yii\web\View */
/* @var $searchModel app\models\VacunaSearch */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Vacunas';
if(Yii::$app->user->isGuest){
  if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
		$uri = 'https://';
	} else {
		$uri = 'http://';
	}
	$uri .= $_SERVER['HTTP_HOST'];
	header('Location: '.$uri.'/vacunatorio/web/index.php/site/login');
	exit; 
	}
	$session = Yii::$app->session;
	if($session->get('vacuna')){ ?>
		<script>alert("Vacuna creada correctamente"); </script>
		<?php 
			$session->set('vacuna',0);
		} 
		$mpdf = new \Mpdf\Mpdf();
	ob_start();
?>
</br>

<div class="vacuna-index">
    <h1><?= Html::encode($this->title) ?></h1>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <?= GridView::widget([
        'dataProvider' => $dataProvider,
       
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            //'vac_codigo',
            'vac_nombre',
            'vac_tipo',
            'vac_descripcion',
            'vac_stock',
            'vac_dosis',
            //'vac_del',
            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
	<?php
$html = ob_get_contents();
ob_end_clean();
$mpdf->WriteHTML($html);
$mpdf->Output();
exit;
?>
</div>
<?= Html::a("<i class='glyphicon glyphicon-chevron-left'></i>",
				Yii::$app->homeUrl,['class'=>'btn btn-primary col-xs-12', 'style' => 'margin-bottom: 10px']) ?>

views/vacuna/list.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;
use app\models\Vacuna;

$vacuna=Vacuna::find()->all();

/* @var $this yii\web\View */
/* @var $model app\models\Vacuna */
/* @var $form yii\widgets\ActiveForm */
if(Yii::$app->user->isGuest){
  if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
		$uri = 'https://';
	} else {
		$uri = 'http://';
	}
	$uri .= $_SERVER['HTTP_HOST'];
	header('Location: '.$uri.'/vacunatorio/web/index.php/site/login');
	exit; 
	}
?>

<div class="vacuna-form">

 <?php
 for($i=0;$i<sizeof($vacuna);$i++){ 
	 ?>
	 <?= Html::a($vacuna[$i]->vac_nombre, ['/vacuna/update/'.$vacuna[$i]->vac_codigo],[''=>'','class'=>'btn btn-lg btn-success']) ?>
	 </br>
 <?php
	 }
 ?>

</div>

views/vacuna/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Vacuna */

$this->title = 'Editar Vacuna: '.$model->vac_nombre;
if(Yii::$app->user->isGuest){
  if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
		$uri = 'https://';
	} else {
		$uri = 'http://';
	}
	$uri .= $_SERVER['HTTP_HOST'];
	header('Location: '.$uri.'/vacunatorio/web/index.php/site/login');
	exit; 
	}
?>
</br>
<div class="vacuna-update">

    <h1><?= Html::encode($this->title) ?></h1>
	<div class="panel panel-primary">
		<div class="panel-body" >
			 <?= $this->render('_form', [
				'model' => $model,
			]) ?>	
		</div>		
	</div>
   

</div>
<?= Html::a("<i class='glyphicon glyphicon-chevron-left'></i>", ['/vacuna/'],
['class'=>'btn btn-primary col-xs-12', 'style' => 'margin-bottom: 10px']) ?>

views/vacuna/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;
use Mpdf\Mpdf;
/* @var $this yii\web\View */
/* @var $model app\models\Vacuna */



$this->title = 'Datos de la Vacuna';

//$model->vac_nombre='prueba';
//$model->save();

if(Yii::$app->user->isGuest){
  if (!empty($_SERVER['HTTPS']) && ('on' == $_SERVER['HTTPS'])) {
		$uri = 'https://';
	} else {
		$uri = 'http://';
	}
	$uri .= $_SERVER['HTTP_HOST'];
	header('Location: '.$uri.'/vacunatorio/web/index.php/site/login');
	exit; 
	}
	
	

?>

<div class="vacuna-view">
    <h1><?= Html::encode($this->title) ?></h1>
    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            //'vac_codigo',
            'vac_nombre',
            'vac_tipo',
            'vac_descripcion',
            'vac_stock',
            'vac_dosis',
            //'vac_del',
        ],
    ]) ?>
</div>

<?= Html::a("<i class='glyphicon glyphicon-chevron-left'></i>", ['/vacuna/'],['class'=>'btn btn-primary	col-xs-12']) ?>